//-----------------------------------------------------------------------------
//
//  CircularBuffer.h++
//
//  Circular Buffer Class Declaration
//
//  Tony Jebara (Copyright (C) 1997)
//  Brian Clarkson
//
//-----------------------------------------------------------------------------

#ifndef CircularBuffer_h
#define CircularBuffer_h

#define DEFAULT_CIRCULAR_BUFFER_SIZE 10000

template<class T> class CircularBuffer {

  // Construction/Destruction
public:
  CircularBuffer();
  CircularBuffer(int n);
  ~CircularBuffer();

protected:
  // For holding the data
  T * data;
  int pos;
  int size;
private:
  // A temp buffer for GetLast
  T * tmp;

public:
  void Reset();
  void Reset(int n);
  void Add(T * newdata, int len);
  T * GetLast(int len);

};

typedef CircularBuffer<int> CircularIntBuffer;
typedef CircularBuffer<float> CircularFloatBuffer;
typedef CircularBuffer<char> CircularCharBuffer;

#endif
